<?php
require_once(_PS_MODULE_DIR_ . 'categoryquantitydiscount/PrestoChangeoClasses/init.php');
class CategoryQuantityDiscount extends PrestoChangeoModule
{
 	private $_html = '';
	private $_cqd_categories = '';
	protected $_full_version = 14000;
 	protected $_last_updated = '';
	private $_ps_version_id = 0;
	
 	function __construct()
	{
	
		$ps_version_array = explode('.', _PS_VERSION_);
		$this->_ps_version_id = 10000 * intval($ps_version_array[0]) + 100 * intval($ps_version_array[1]);
		if (count($ps_version_array) >= 3)
			$this->_ps_version_id += intval($ps_version_array[2]);
			
		$this->name = 'categoryquantitydiscount';
		$this->tab = floatval(substr(_PS_VERSION_,0,3))<1.4?'Presto-Changeo':'administration';
		$this->version = '1.4';
		if (floatval(substr(_PS_VERSION_,0,3)) >= 1.4)
			$this->author = 'Presto-Changeo';
		
		parent::__construct();
				
		if ($this->_ps_version_id >= 10600)	
			$this->bootstrap = true;
			
		$this->_refreshProperties();
		
		$this->displayName = $this->l('Category Quantity Discount');
		$this->description = $this->l('Extend Quantity Discount to all products in a category.');
		if ($this->upgradeCheck('CQD'))
			$this->warning = $this->l('We have released a new version of the module,') .' '.$this->l('request an upgrade at ').' https://www.presto-changeo.com/en/contact_us';
	}
	
	
	function install()
	{
		if (!parent::install())
			return false;
		Configuration::updateValue('CQD_CATEGORIES','');			
		Configuration::updateValue('PRESTO_CHANGEO_UC',time());			
		return true;
	}

	private function _refreshProperties()
	{
		$this->_last_updated = Configuration::get('PRESTO_CHANGEO_UC');
		$this->_cqd_categories = Configuration::get('CQD_CATEGORIES');
	}

	public function getContent()
	{
		$this->_html = $this->getModuleRecommendations('CQD').'<h2 style="clear:both;padding-top:5px;">'.$this->displayName.' '.$this->version.'</h2>';
		$this->_postProcess();
		$this->_displayForm();
		$ps_version  = floatval(substr(_PS_VERSION_,0,3));
		
		return ($ps_version >= 1.5 ? ''.($this->_ps_version_id < 10600 ? '<div style="width: 980px; margin: 0 auto;">' : '<div>').'' : '').$this->_html.($ps_version >= 1.5 ? '</div>' : '');
	}
	
    private function _displayForm()
    {
    	global $cookie;
		$ps_version  = floatval(substr(_PS_VERSION_,0,3));
		$ps_version3  = substr(_PS_VERSION_,0,5).(substr(_PS_VERSION_,5,1) != "."?substr(_PS_VERSION_,5,1):"");
    	
 		$ps_version3_array = array("1.4.0","1.4.1","1.4.2","1.4.3","1.4.4","1.4.5","1.4.6","1.4.7","1.4.8","1.4.9","1.4.10","1.4.11","1.5.0","1.5.1","1.5.2","1.5.3","1.5.4","1.5.5","1.5.6","1.6.0","1.6.1");
    	$server_file = @file_get_contents(dirname(__FILE__).'/../../override/classes/Product.php');
    	$modified_file = @file_get_contents(dirname(__FILE__).'/modified_'.$ps_version3.'/override/classes/Product.php');
    	$is_match = false;
    	if ($server_file != '' && $server_file == $modified_file)
    		$is_match = true;
			
		if ($url = $this->upgradeCheck('QDC'))
			$this->_html .= '
			'.($this->_ps_version_id < 10600 ? '<fieldset class="width3" style="background-color:#FFFAC6;width:800px;">' : '<div class="panel">').' 
				'.($this->_ps_version_id < 10600 ? '<legend>' : '<h3>').'
					<img src="'.$this->_path.'logo.gif" />&nbsp;&nbsp;&nbsp;'.$this->l('New Version Available').'
				'.($this->_ps_version_id < 10600 ? '</legend>' : '</h3>' ).'
			'.$this->l('We have released a new version of the module. For a list of new features, improvements and bug fixes, view the ').'<a href="'.$url.'" target="_index"><b><u>'.$this->l('Change Log').'</b></u></a> '.$this->l('on our site.').'
			<br />
			'.$this->l('For real-time alerts about module updates, be sure to join us on our') .' <a href="http://www.facebook.com/pages/Presto-Changeo/333091712684" target="_index"><u><b>Facebook</b></u></a> / <a href="http://twitter.com/prestochangeo1" target="_index"><u><b>Twitter</b></u></a> '.$this->l('pages').'.
			<br />
			<br />
			'.$this->l('Please').' <a href="https://www.presto-changeo.com/en/contact_us" target="_index"><b><u>'.$this->l('contact us').'</u></b></a> '.$this->l('to request an upgrade to the latest version').'.
			 '.($this->_ps_version_id < 10600 ? '</fieldset>' : '</div>' ).'
			
			<br />';
    	$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" name="facebooklike_form" id="facebooklike_form" method="post">
		
			'.($this->_ps_version_id < 10600 ? '<fieldset class="width3" style="width:850px;">' : '<div class="panel">').' 
				'.($this->_ps_version_id < 10600 ? '<legend>' : '<h3>').'
					<img src="'.$this->_path.'logo.gif" />&nbsp;&nbsp;&nbsp;'.$this->l('Installation Instructions').'
				'.($this->_ps_version_id < 10600 ? '</legend>' : '</h3>' ).'
				<table '.($this->_ps_version_id < 10600 ? 'width="850"' : 'width="100%"').'>
				<tr height="40">
					<td align="left">'.(!in_array($ps_version3, $ps_version3_array)?'<li style="margin-left:10px"><b style="color:red">'.$this->l('This version of Prestahsop is not yet supported by the module.').'</b></li>':'
						<li style="margin-left:2px"><b>'.$this->l('The line below will appear in').'<b style="color:red"> '.$this->l('RED').'</b> '.$this->l('until you copy the modified file, it will turn').' <b style="color:green">'.$this->l('GREEN').'</b> '.$this->l('after you copy the file and reload the page').'.</b></li>
						<br />
						<li style="margin-left:2px">'.$this->l('Copy').' <b style="color:'.($is_match?'green':'red').'">/module/categoryquantitydiscount/modified_'.$ps_version3.'/override/classes/Product.php &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$this->l('to').'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /override/classes/</b></li>
						<br />
						<li style="margin-left:2px"><b style="Color:blue">'.$this->l('If you already have Product.php in /override/classes/ you will need to copy or merge the "getPriceStatic()" function from our modified file').'.</b></li>
						').'
					</td>
				</tr>
				</table>
				 '.($this->_ps_version_id < 10600 ? '</fieldset>' : '</div>' ).'
			<br />
		'.($this->_ps_version_id < 10600 ? '<fieldset class="width3" style="width:850px;">' : '<div class="panel">').' 
			'.($this->_ps_version_id < 10600 ? '<legend>' : '<h3>').'
				<img src="'.$this->_path.'logo.gif" />&nbsp;&nbsp;&nbsp;'.$this->l('Category Quantity Discount Settings').'
			'.($this->_ps_version_id < 10600 ? '</legend>' : '</h3>' ).'
			<table border="0" '.($this->_ps_version_id < 10600 ? 'width="850"' : 'width="100%"').'>
			<tr  '.($this->_ps_version_id < 10600 ? 'height="30"' : 'height="36"').'>
				<td align="left" valign="top" width="120">
					<b>'.$this->l('Enter Categories').':</b> 
				</td>
				<td align="left" valign="top">
					<input type="text" name="cqd_categories" value="'.Tools::getValue('cqd_categories', $this->_cqd_categories).'" size="60" />
					'.$this->l('Category ID, comma delimited (IE 2,5,7)').'
				</td>
			</tr>
			<tr>
				<td colspan="2" align="center">
					<input type="submit" value="'.$this->l('Update').'" name="submitChanges" '.($this->_ps_version_id >= 10600 ? 'class="btn btn-default"' : 'class="button" ' ).' />
				</td>
			</tr>
			</table>
			 '.($this->_ps_version_id < 10600 ? '</fieldset>' : '</div>' ).'
		</form>';
   	}
    	    
	private function _postProcess()
	{
		if (Tools::isSubmit('submitChanges'))
		{
			if (!Configuration::updateValue('CQD_CATEGORIES', Tools::getValue('cqd_categories')))
				$this->_html .= '<div class="alert error">'.$this->l('Cannot update settings').'</div>';
			else
				$this->_html .= ($this->_ps_version_id >= 10600 ?  '<div class="alert alert-success">
			<button type="button" class="close" data-dismiss="alert">×</button>
			'.$this->l('Settings updated').'
		</div>' : '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />'.$this->l('Settings updated').'</div>');
		}
		$this->_refreshProperties();
	}
	
	public function getRealQuantity($id_product, $id_cart, $quantity)
	{
		if ($this->_cqd_categories == '')
			return $quantity;
		$ps_version  = floatval(substr(_PS_VERSION_,0,3));
		$query = 'SELECT * FROM '._DB_PREFIX_.'category_product cp
			'.($ps_version >= 1.5 ? 'LEFT JOIN '._DB_PREFIX_.'category_shop cps ON cp.id_category = cps.id_category ' : '').'
			WHERE	'.($ps_version >= 1.5  ? ' cps.id_shop = '.Context::getContext()->shop->id.' AND ' : '').'
			cp.id_product = '.$id_product.' AND cp.id_category IN ('.$this->_cqd_categories.') LIMIT 1';
		$res = Db::getInstance()->ExecuteS($query);
		if (is_array($res) && sizeof($res) > 0)
			$id_category = $res[0]['id_category'];
		else
			return $quantity;
		$query = 'SELECT SUM( cp.quantity ) AS sum
			FROM  `'._DB_PREFIX_.'cart_product` AS cp, '._DB_PREFIX_.'category_product AS cap
			WHERE  
			'.($ps_version >= 1.5  ? ' cp.id_shop = '.Context::getContext()->shop->id.' AND ' : '').'
			`id_cart` = '.(int)$id_cart.'
			AND cp.id_product = cap.id_product
			AND cap.id_category = '.$id_category;
		//echo $query;
		$res = Db::getInstance()->ExecuteS($query);
		
		if (is_array($res) && sizeof($res) > 0 && $res[0]['sum'] > 0)
			return $res[0]['sum'];
		else
			return $quantity;
	}
	
	
}
?>